/***************************************************************************************
*
* ID1.asm
*
* Accompaniment for:
* Guide for Porting Code from SHARC DSPs to TigerSHARC Processors (EE-241)
*
* Written by Andrew Caldwell and Maikel Kokaly-Bannourah 
*	
* June 2004 rev 1.0 
*
* This is a TigerSHARC equivalent version of the SHARC Multiprocessor example
* provided with this EE-note (see EE241.zip)
*
***************************************************************************************/

#define N 16

/* DM data section in Memory Block 1 */
.section data1;
.align 4;
.var rx_buff_ID1[N];				// ID1 receive buffer for external port (DMA) data transfer from ID0


/* PM code in Memory Block 0 */
.section program;

start_ID1:
      
	/* Setting Up of Control Registers */

	j14 = j31 + 0x3a79e7;;			// Initial value after reset (0x279e7) modified 
    SYSCON = j14;;					// for 64-bit Bus width configuration

	/* DMA set up */

	XR0 = 0x00000000;;		
	XR1 = 0x00000000;;		
	XR2 = 0x00000000;;		
	XR3 = 0x00000000;;		

	XR1 = 0x00040004;;				// Count =4, modify = 4 for quad word accesses
	XR3 = 0x00000000;;				// Disable DMA
	DC12 = XR3:0;;					// Set up DMA Channel 12 

	j0 = j31 + _dma_int;;			// Set up DMA12 interrupt vector
	IVDMA12 = j0;;
		
	/* Enable interrupts - DMA12 and GLOBAL int. */

	xR0 = IMASKH;;					// Read value of IMASKH
	xR1 = 0x10000020;;				// DMA12 and Global interrupts
	xR5 = R1 or R0;;				// OR with contents of IMASKH
	IMASKH = xR5;;					// Write back to IMASKH
 		
	/* Set up and perform DMA transfers */

										// AutoDMA0 - DMA Channel 12
	xr0 = rx_buff_ID1;;					// xr0 = source index = int. mem. DSP_1
	xr1 = 0x00100001;;					// count = 0x10, modify = 1 (normal word)
	xr3 = 0x53000000;;					// int mem,prio=norm,2D=no,word=32-bit,int=yes,RQ=enbl,chain=no
	DC12 = xr3:0;;						// Set up source for transfer

/* Terminate and wait */
wait1:   jump wait1;;

_dma_int:	

	nop;;nop;;nop;;rti(ABS);;				//	DMA12 Interrupt vector


